/****************************************************************************/
/** atom.cpp                                                               **/
/** ---------------------------------------------------------------------- **/
/** Demonstrates usage of TAtomOf and TAtomMasterOf templates              **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** January 26, 1998 by Oleg Kagan                                         **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>  // recommended for better compilation time
#pragma hdrstop

//============================================================================
#include <iostream.h>

//============================================================================
#include <nlstring.h>
#include <nlatom.h>

//============================================================================
USING_NATLIB_NAMESPACE

//============================================================================
//NLATOM_DECLSPEC(TStdString, NATLIB_NOTHING);

//============================================================================
void AtomExample() 
{
	TStdStringCaseSensitiveComparator StrComparator;

	TAtomMasterOf<TStdString> StrMaster(StrComparator, false);

	{
		TAtomOf<TStdString> StrAtom1(StrMaster.CreateAtom("Hello"));
		cout << StrAtom1.Value().c_str();
		cout << ":" << StrAtom1.References() << endl;

		TAtomOf<TStdString> StrAtom2(StrMaster.CreateAtom("Hello"));
		StrAtom2 = "Hello1";

		cout << StrMaster.Dump().c_str() << endl;
	}
	cout << StrMaster.Dump().c_str() << endl;

	StrMaster.CollectGarbage(-1);
	cout << StrMaster.Dump().c_str() << endl;
} /*AtomExample*/