/****************************************************************************/
/** autopt.cpp                                                             **/
/** ---------------------------------------------------------------------- **/
/** Demonstrates usage of TAutoDeletePointerTo template                    **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** October 21, 1996 by Oleg Kagan                                         **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>  // recommended for better compilation time
#pragma hdrstop

// Standard includes
//============================================================================
#include <iostream.h>

// Natlib Basics includes
//============================================================================
#include <nlautopt.h>

//============================================================================
USING_NATLIB_NAMESPACE

// TAutoPointerExample
//============================================================================
typedef class TAutoPointerExample {
public:
	//------------------------------------------------------------------------
    int i;
	//------------------------------------------------------------------------
    TAutoPointerExample() {cout << "Construct\n";}
	//------------------------------------------------------------------------
    ~TAutoPointerExample() {cout << "Destruct\n";}
} typedef_TAutoPointerExample;

//============================================================================
//NLAUTOPT_DECLSPEC(TAutoPointerExample, NATLIB_NOTHING);
//NLAUTOPT_DECLSPEC(char, NATLIB_NOTHING);

//============================================================================
void AutoPointerExample()
{
	{ // begin scope
    	TAutoPointerTo<TAutoPointerExample> AutoPtr(
        	new TAutoPointerExample, false
        ) /*AutoPtr*/;
    } /*end scope*/

    try {
    	TAutoPointerTo<TAutoPointerExample> AutoPtr(
        	new TAutoPointerExample, false
        ) /*AutoPtr*/;
		throw int(10);
    } /*try*/
    catch (const int&) {};

    { // begin scope
		const size_t nSize = 10;
	    TAutoPointerTo<TAutoPointerExample> Ptrs[nSize];

	   	TAutoPointerTo<TAutoPointerExample> AutoPtr(
	       	new TAutoPointerExample, false
		) /*AutoPtr*/;

	    for (size_t i = 0; i < nSize; ++i)
        	Ptrs[i] = AutoPtr;
    } /*end scope*/

    TAutoPointerTo<char> hHandle(new char[10], true);
 } /*AutoPointerExample()*/

