/****************************************************************************/
/** time.cpp                                                               **/
/** ---------------------------------------------------------------------- **/
/** Demonstrates usage of TTime class                                      **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** May 27, 1997 by Ilya Marchevsky                                        **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>  // recommended for better compilation time
#pragma hdrstop

// Standard includes
//============================================================================
#include <iostream.h>

// Natlib Basics includes
//============================================================================
#include <nltime.h>

// Natlib Win32 includes
//============================================================================
#include <nwconsol.h>

//============================================================================
USING_NATLIB_NAMESPACE

//============================================================================
void DumpTime(const TTime& c_Time, const char* Name = null)
{
    char buffer[40];
    sprintf(buffer, "[%d,%d]", c_Time.GetDays(), c_Time.GetMSeconds());
    if (Name)
    	cout << Name << ": ";
    cout << buffer << endl;
} /*DumpTime(const TTime&)*/

//============================================================================
void PrintTime(

	const TTime& c_Time,
    const char* c_szName = null

){
	TTime::TCalendarForm CalendarForm;
    c_Time.Time(CalendarForm);

    char szBuffer[40];
    sprintf(
    	szBuffer, "%04d.%02d.%02d %02d:%02d:%02d ",
        CalendarForm.nYear, CalendarForm.nMonth, CalendarForm.nDay,
        CalendarForm.nHour, CalendarForm.nMinute, CalendarForm.nSecond
    ) /*sprintf*/;
    if (c_szName) cout << c_szName << ": ";
    cout << szBuffer;
    DumpTime(c_Time);
} /*PrintTime(const TTime&)*/

//============================================================================
void TimeExample()
{
	cout << "Time Example" << endl;
    TTime TheTime(1980,1,1); // it was a leap year...
    TStdString String(TheTime.AsString());
    PrintTime(TheTime, "TheTime");
    TTime AfterYear = TheTime;
    AfterYear.AddYears(1);
    PrintTime(AfterYear, "AfterYear");
    TTime DiffTime = TheTime - AfterYear;
    DumpTime(DiffTime, "DiffTime");
    TTime Time1 = DiffTime + TTime(0, 1000);
    DumpTime(Time1, "Time1");
    if (Time1 > DiffTime)
    	cout << "Time1 > DiffTime" << endl;
    else if (Time1 < DiffTime)
    	cout << "Time1 < DiffTime" << endl;
    else
    	cout << "Time1 == DiffTime" << endl;
    AfterYear += DiffTime;
    PrintTime(AfterYear, "The Time");
    TTime Now;
    PrintTime(Now, "Now");
    cout << "Today is " << TTime::DayOfWeekName(Now.DayOfWeek()) << endl;
} /*TimeExample()*/
