#ifndef __NATLIB_NLBC_H__
#define __NATLIB_NLBC_H__
/****************************************************************************/
/** nlbc.h                                                                 **/
/** ---------------------------------------------------------------------- **/
/** Borland C++ compatibility tools (see nlcompat.h)                       **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** November 18, 1996 by Oleg Kagan                                        **/
/****************************************************************************/

//============================================================================
#if defined(__BCPLUSPLUS__)  // Borland compilers
	//------------------------------------------------------------------------
	#if (__BORLANDC__ < 0x500)
        // Standard types, exceptions and RTTI
        //--------------------------------------------------------------------
        #include <stddef.h>
        #include <except.h>
        #include <typeinfo.h>
        #include <new.h>

        //--------------------------------------------------------------------
        typedef typeinfo type_info;
        typedef Bad_cast bad_cast;

        //--------------------------------------------------------------------
        #define _NATLIB_THROW_NONE_ throw()
        #define _NATLIB_THROW_(Ex1) throw(Ex1)
        #define _NATLIB_THROW1_(Ex1) throw(Ex1)
        #define _NATLIB_THROW2_(Ex1, Ex2) throw(Ex1, Ex2)
        #define _NATLIB_THROW3_(Ex1, Ex2, Ex3) throw(Ex1, Ex2, Ex3)
        #define _NATLIB_THROW4_(Ex1, Ex2, Ex3, Ex4) throw(Ex1, Ex2, Ex3, Ex4)

    	//--------------------------------------------------------------------
       	#if !defined(_NATLIB_NO_WIDE_STRINGS_)
           	#define _NATLIB_NO_WIDE_STRINGS_
        #endif /*!defined(_NATLIB_NO_WIDE_STRINGS_)*/

		//--------------------------------------------------------------------
       	#include <cstring.h>
		typedef string TNatlibStdString;
        #define npos NPOS

		// Scalar types
        //--------------------------------------------------------------------
        typedef signed char nl_char_t;
        typedef unsigned char nl_uchar_t;
        typedef wchar_t nl_wchar_t;
        typedef short nl_short_t;
        typedef unsigned short nl_ushort_t;
        typedef int nl_int_t;
        typedef unsigned int nl_uint_t;
        typedef long nl_long_t;
        typedef unsigned long nl_ulong_t;

		//--------------------------------------------------------------------
		#define bool	int
		#define true	1
		#define false	0
		#define typename class
		#define explicit
        #define mutable

		#define _NATLIB_NO_BOOL_

		//--------------------------------------------------------------------
        #define _NATLIB_NO_NAMESPACE_

        //--------------------------------------------------------------------
		#define _NATLIB_NO_EXPLICIT_TEMPLATE_DECLSPEC_

        //--------------------------------------------------------------------
		#define NATLIB_EXPAND_TEMPLATE(Template, Declspec)
		#define NATLIB_EXPAND_TEMPLATE1(Template, T1, Declspec)
		#define NATLIB_EXPAND_TEMPLATE2(Template, T1, T2, Declspec)
		#define NATLIB_EXPAND_TEMPLATE3(Template, T1, T2, T3, Declspec)
        #define NATLIB_EXPAND_TEMPLATE4(Template, T1, T2, T3, T4, Declspec)

        //--------------------------------------------------------------------
        #define _NATLIB_NO_EXTENDED_OVERLOADING_

        //--------------------------------------------------------------------
        #define _NATLIB_EXPLICIT_TEMPLATE_

        //--------------------------------------------------------------------
//		#define NATLIB_INIT {set_new_handler(null);}

        //--------------------------------------------------------------------
        #define NATLIB_XALLOC xalloc
		#define NATLIB_XALLOC_REQUESTED(x) (x.requested())

        //--------------------------------------------------------------------
		#define NATLIB_FUNC_DECL(Declspec, ReturnType) ReturnType Declspec
    #else  // BC 5.xx
		// Standard types, exceptions and RTTI
        //--------------------------------------------------------------------
        #include <stddef.h>
        #include <except.h>
        #include <typeinfo.h>
        #include <new.h>

        //--------------------------------------------------------------------
        typedef typeinfo type_info;
        typedef Bad_cast bad_cast;

        //--------------------------------------------------------------------
        #define _NATLIB_THROW_NONE_ throw()
        #define _NATLIB_THROW_(Ex1) throw(Ex1)
        #define _NATLIB_THROW1_(Ex1) throw(Ex1)
        #define _NATLIB_THROW2_(Ex1, Ex2) throw(Ex1, Ex2)
        #define _NATLIB_THROW3_(Ex1, Ex2, Ex3) throw(Ex1, Ex2, Ex3)
        #define _NATLIB_THROW4_(Ex1, Ex2, Ex3, Ex4) throw(Ex1, Ex2, Ex3, Ex4)

		// Scalar types
		//--------------------------------------------------------------------
		typedef signed char nl_char_t;
		typedef unsigned char nl_uchar_t;
		typedef wchar_t nl_wchar_t;
		typedef short nl_short_t;
		typedef unsigned short nl_ushort_t;
		typedef int nl_int_t;
		typedef unsigned int nl_uint_t;
		typedef long nl_long_t;
		typedef unsigned long nl_ulong_t;

    	// Use the next definition to use Borland "string" class
        // instead of STL string
    	//--------------------------------------------------------------------
//		#define _NATLIB_USE_STL_STRING_CLASS_
        #define _NATLIB_NO_WIDE_STRINGS_

		//--------------------------------------------------------------------
        #if !defined(_NATLIB_USE_STL_STRING_CLASS_)
        	#if !defined(_NATLIB_NO_WIDE_STRINGS_)
            	#define _NATLIB_NO_WIDE_STRINGS_
            #endif /*!defined(_NATLIB_NO_WIDE_STRINGS_)*/
		#endif /*!defined(_NATLIB_USE_STL_STRING_CLASS_)*/
		#define vswprintf wvsprintfW

		//--------------------------------------------------------------------
    	#if !defined(_NATLIB_USE_STL_STRING_CLASS_)
        	#include <cstring.h>
			typedef string TNatlibStdString;
            #define npos NPOS
    	#else
            //----------------------------------------------------------------
        	#include <string>
			typedef std::string TNatlibStdString;
			#define npos std::string::npos

			//----------------------------------------------------------------
			#if !defined(_NATLIB_NO_WIDE_STRINGS_)
				//------------------------------------------------------------
				template class _NATLIB_DECLSPEC_ std::basic_string<
					wchar_t, std::string_char_traits<wchar_t>,
					std::RWSTD_ALLOC_TYPE(wchar_t)
				> /*std::basic_string*/;
				//------------------------------------------------------------
				typedef std::basic_string<
					wchar_t, std::string_char_traits<wchar_t>,
					std::RWSTD_ALLOC_TYPE(wchar_t)
				> /*std::basic_string*/ TNatlibWideString;
			#endif /*!defined(_NATLIB_NO_WIDE_STRINGS_)*/
    	#endif /*!defined(_NATLIB_USE_STL_STRING_CLASS_)*/

        //--------------------------------------------------------------------
        #define _NATLIB_TEMPLATE_DECLSPEC_
        #define _NATLIB_TASKS_TEMPLATE_DECLSPEC_

        //--------------------------------------------------------------------
        #define NATLIB_EXPAND_TEMPLATE(Template,  Declspec) \
            template class Declspec Template
        //--------------------------------------------------------------------
        #define NATLIB_EXPAND_TEMPLATE1(Template, T1, Declspec) \
            template class Declspec Template < T1 >
        //--------------------------------------------------------------------
        #define NATLIB_EXPAND_TEMPLATE2(Template, T1, T2, Declspec) \
            template class Declspec Template < T1, T2 >
        //--------------------------------------------------------------------
        #define NATLIB_EXPAND_TEMPLATE3(Template, T1, T2, T3, Declspec) \
            template class Declspec Template < T1, T2, T3 >
        //--------------------------------------------------------------------
        #define NATLIB_EXPAND_TEMPLATE4(Template, T1, T2, T3, T4, Declspec) \
            template class Declspec Template < T1, T2, T3, T4 >

        //--------------------------------------------------------------------
        #define _NATLIB_EXPLICIT_TEMPLATE_
        //--------------------------------------------------------------------
//		#define NATLIB_INIT {set_new_handler(null);}
        //--------------------------------------------------------------------
        #define NATLIB_XALLOC xalloc
		#define NATLIB_XALLOC_REQUESTED(x) (x.requested())

        //--------------------------------------------------------------------
		#define NATLIB_FUNC_DECL(Declspec, ReturnType) ReturnType Declspec
	#endif /*(__BORLANDC__ < 0x500)*/
#else
	#error nlbc.h can be only used with Borland compilers family
#endif /*__BCPLUSPLUS__*/

#endif /*!defined(__NATLIB_NLBC_H__)*/
