#ifndef __NATLIB_NLCMPTEX_H__
#define __NATLIB_NLCMPTEX_H__
/****************************************************************************/
/** nlcmptex.h                                                             **/
/** ---------------------------------------------------------------------- **/
/** Compatibility enhanced tools                                           **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** August 15, 1998 by Oleg Kagan                                          **/
/****************************************************************************/

//============================================================================
#include <nlexcept.h>
#include <nllock.h>

//============================================================================
NATLIB_NAMESPACE_BEGIN

// TNatlibCompatibilityCore
//============================================================================
class _NATLIB_DECLSPEC_ TNatlibCompatibilityCore {
public:
	//------------------------------------------------------------------------
	static TNatlibCompatibilityCore& GetCore();

	//------------------------------------------------------------------------
	virtual size_t WideToStd(
		const wchar_t* c_wszSource, char* szDestination, size_t nToConvert 
	) /*WideToStd(const wchar_t*, char*, size_t)*/ = 0;

	//------------------------------------------------------------------------
	virtual size_t StdToWide(
		const char* c_szSource,  wchar_t* wszDestination, size_t nToConvert  
	) /*StdToWide(const char*, wchar_t*, size_t)*/ = 0;

	//------------------------------------------------------------------------
	virtual TLock& CreateLock() = 0;
} /*TNatlibCompatibilityCore*/;

//============================================================================
NATLIB_NAMESPACE_END

#endif /*!defined(__NATLIB_NLCMPTEX_H__)*/