#ifndef __NATLIB_NLGPP_H__
#define __NATLIB_NLGPP_H__
/****************************************************************************/
/** nlgpp.h                                                                **/
/** ---------------------------------------------------------------------- **/
/** Borland C++ compatibility tools (see nlcompat.h)                       **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** March 23, 1996 by Oleg Kagan                                           **/
/****************************************************************************/

//============================================================================
#if defined(__GNUG__)  // Borland compilers
    // Standard types, exceptions and RTTI
    //------------------------------------------------------------------------
    #include <stddef.h>
    #include <typeinfo>
    #include <exceptio>
    #include <string>

	// Scalar types
	//--------------------------------------------------------------------
	typedef signed char nl_char_t;
	typedef unsigned char nl_uchar_t;
	typedef wchar_t nl_wchar_t;
	typedef short nl_short_t;
	typedef unsigned short nl_ushort_t;
	typedef int nl_int_t;
	typedef unsigned int nl_uint_t;
	typedef long nl_long_t;
	typedef unsigned long nl_ulong_t;

	//------------------------------------------------------------------------
	#define _NATLIB_THROW_NONE_
	#define _NATLIB_THROW_(Ex1)
	#define _NATLIB_THROW1_(Ex1)
	#define _NATLIB_THROW2_(Ex1, Ex2)
	#define _NATLIB_THROW3_(Ex1, Ex2, Ex3)
	#define _NATLIB_THROW4_(Ex1, Ex2, Ex3, Ex4)

	//------------------------------------------------------------------------
    #define _NATLIB_NO_NAMESPACE_
	#define _NATLIB_NO_EXTENDED_OVERLOADING_

    //------------------------------------------------------------------------
    #define _NATLIB_NO_WIDE_STRINGS_
    typedef string TNatlibStdString;

    //------------------------------------------------------------------------
    #define NATLIB_XALLOC TXLowMemory
	#define NATLIB_XALLOC_REQUESTED(x) (x.Requested())

    //------------------------------------------------------------------------
	#define _NATLIB_TEMPLATE_DECLSPEC_

    //------------------------------------------------------------------------
    #define NATLIB_EXPAND_TEMPLATE(Template, Declspec) \
		template class Declspec Template
    //------------------------------------------------------------------------
    #define NATLIB_EXPAND_TEMPLATE1(Template, T1, Declspec) \
        template class Declspec Template < T1 >
    //------------------------------------------------------------------------
    #define NATLIB_EXPAND_TEMPLATE2(Template, T1, T2, Declspec) \
		template class Declspec Template < T1, T2 >
    //------------------------------------------------------------------------
    #define NATLIB_EXPAND_TEMPLATE3(Template, T1, T2, T3, Declspec) \
		template class Declspec Template < T1, T2, T3 >
    //------------------------------------------------------------------------
    #define NATLIB_EXPAND_TEMPLATE4(Template, T1, T2, T3, T4, Declspec) \
		template class Declspec Template <T1, T2, T3, T4 >

    //------------------------------------------------------------------------
	#define _NATLIB_EXPLICIT_TEMPLATE_

 	//------------------------------------------------------------------------
    #define NATLIB_INIT {set_new_handler(null);}

    //------------------------------------------------------------------------
    #define NATLIB_FUNC_DECL(Declspec, ReturnType) ReturnType Declspec

#else
	#error nlgnu.h can be only used with Borland compilers family
#endif /*__GNUG__*/

#endif /*!defined(__NATLIB_NLGPP_H__)*/
