#ifndef __NATLIB_NLMSC_H__
#define __NATLIB_NLMSC_H__
/****************************************************************************/
/** nlmcs.h                                                                **/
/** ---------------------------------------------------------------------- **/
/** Microsoft C++ compatibility tools (see nlcompat.h)                     **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1997-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** November 18, 1996 by Oleg Kagan                                        **/
/****************************************************************************/

//============================================================================
#if defined(_MSC_VER)
    #if (_MSC_VER >= 1100)
		//--------------------------------------------------------------------
		#pragma inline_depth(3)

        //--------------------------------------------------------------------
		#pragma warning( disable : 4003 ) // C4003
//		#pragma warning( disable : 4097 ) // C4097
		#pragma warning( disable : 4099 ) // C4099
//		#pragma warning( disable : 4237 ) // C4237
		#pragma warning( disable : 4250 ) // C4250
		#pragma warning( disable : 4660 ) // C4660
		#pragma warning( disable : 4661 ) // C4661
		#pragma warning( disable : 4786 ) // C4786
		#pragma warning( disable : 4800 ) // C4800

        // Standard types, exceptions and RTTI
        //--------------------------------------------------------------------
        #include <stddef.h>
        #include <stdexcpt.h>
        #include <typeinfo.h>
		
		// Scalar types
		//--------------------------------------------------------------------
		typedef signed char nl_char_t;
		typedef unsigned char nl_uchar_t;
		typedef wchar_t nl_wchar_t;
		typedef short nl_short_t;
		typedef unsigned short nl_ushort_t;
		typedef int nl_int_t;
		typedef unsigned int nl_uint_t;
		typedef long nl_long_t;
		typedef unsigned long nl_ulong_t;

		// Use the next definition to use Visual C++ original STL string class
		// instead of HP STL class
        //--------------------------------------------------------------------
//		#define _NATLIB_USE_STL_STRING_CLASS_ 1

		//--------------------------------------------------------------------
		#if !defined(_NATLIB_USE_STL_STRING_CLASS_)
			#include <string>

			// string definition according to _NATLIB_DECLSPEC_
			//----------------------------------------------------------------
//			template class _NATLIB_DECLSPEC_ std::basic_string<
//				char, std::char_traits<char>, std::allocator<char> 
//			> /*std::basic_string*/;
//			typedef std::basic_string<
//				char, std::char_traits<char>, std::allocator<char> 
//			> /*std::basic_string*/ TNatlibStdString;

			// wstring definition according to _NATLIB_DECLSPEC_
			//----------------------------------------------------------------
//			template class _NATLIB_DECLSPEC_ std::basic_string<
//				wchar_t, std::char_traits<wchar_t>, std::allocator<wchar_t>
//			> /*std::basic_string*/;
//			typedef std::basic_string<
//				wchar_t, std::char_traits<wchar_t>, std::allocator<wchar_t> 
//			> /*std::basic_string*/ TNatlibWideString;

			//----------------------------------------------------------------
			typedef std::string TNatlibStdString;
			#if !defined(_NATLIB_NO_WIDE_STRINGS_)
				typedef std::wstring TNatlibWideString;
			#endif /*!defined(_NATLIB_NO_WIDE_STRINGS_)*/

			//----------------------------------------------------------------
			#define npos TNatlibStdString::npos

			// Redefine windows standard min and max macros
			//----------------------------------------------------------------
			#ifdef min
				#undef min
			#endif /*min*/
			//----------------------------------------------------------------
			template <class T> inline 
			const T& min(const T& a, const T& b) {return b < a ? b : a;}
			//----------------------------------------------------------------
			template <class T, class Compare> inline 
			const T& min(const T& a, const T& b, Compare comp)
			{
				return comp(b, a) ? b : a;
			} /*min(const T&, const T&, Compare)*/
			//----------------------------------------------------------------
			#ifdef max
				#undef max
			#endif /*max*/
			//----------------------------------------------------------------
			template <class T> inline 
			const T& max(const T& a, const T& b) {return  a < b ? b : a;}
			//----------------------------------------------------------------
			template <class T, class Compare>
			inline const T& max(const T& a, const T& b, Compare comp) 
			{
				return comp(a, b) ? b : a;
			} /*max(const T&, const T&, Compare)*/
    	#else
        	#include <bstring.h>
			// string definition according to _NATLIB_DECLSPEC_
			//----------------------------------------------------------------
			template class _NATLIB_DECLSPEC_ basic_string<char>;
			typedef basic_string<char> TNatlibStdString;

			// wstring definition according to _NATLIB_DECLSPEC_
			//----------------------------------------------------------------
			template class _NATLIB_DECLSPEC_ basic_string<wchar_t>;
			typedef basic_string<wchar_t> TNatlibWideString;

			//----------------------------------------------------------------
			#define npos NPOS

			#define _NATLIB_NO_BOOL_ 1
    	#endif /*!defined(_NATLIB_USE_STL_STRING_CLASS_)*/

        //--------------------------------------------------------------------
//		typedef int		bool;
//      #define true	1
//      #define false	0
//      #define typename class
//      #define explicit NATLIB_NOTHING
//      #define mutable NATLIB_NOTHING

		//--------------------------------------------------------------------
//		#define _NATLIB_NO_BOOL_ 1
		
		//--------------------------------------------------------------------
        typedef type_info typeinfo;

        //--------------------------------------------------------------------
		#define _NATLIB_TEMPLATE_DECLSPEC_ NATLIB_NOTHING
		#define _NATLIB_TASKS_TEMPLATE_DECLSPEC_ NATLIB_NOTHING
		
		//--------------------------------------------------------------------
		#define _NATLIB_THROW_NONE_ throw()
		#define _NATLIB_THROW_(Ex1) throw(Ex1)
		#define _NATLIB_THROW1_(Ex1) throw(Ex1)
		#define _NATLIB_THROW2_(Ex1, Ex2) throw(Ex1, Ex2)
		#define _NATLIB_THROW3_(Ex1, Ex2, Ex3) throw(Ex1, Ex2, Ex3)
		#define _NATLIB_THROW4_(Ex1, Ex2, Ex3, Ex4) throw(Ex1, Ex2, Ex3, Ex4)

        //--------------------------------------------------------------------
        #define _NATLIB_NO_EXTENDED_OVERLOADING_ 1

		//--------------------------------------------------------------------
//		#define _NATLIB_NO_NAMESPACE_ 1

        //--------------------------------------------------------------------
		#define NATLIB_EXPAND_TEMPLATE(Template, Declspec) \
			template class Declspec Template
        //--------------------------------------------------------------------
		#define NATLIB_EXPAND_TEMPLATE1(Template, T1, Declspec) \
			template class Declspec Template < T1 >
        //--------------------------------------------------------------------
		#define NATLIB_EXPAND_TEMPLATE2(Template, T1, T2, Declspec) \
			template class Declspec Template < T1, T2 >
        //--------------------------------------------------------------------
		#define NATLIB_EXPAND_TEMPLATE3(Template, T1, T2, T3, Declspec) \
			template class Declspec Template < T1, T2, T3 >
        //--------------------------------------------------------------------
		#define NATLIB_EXPAND_TEMPLATE4(Template, T1, T2, T3, T4, Declspec) \
			template class Declspec Template < T1, T2, T3, T4 >

	    //--------------------------------------------------------------------
		#define _NATLIB_EXPLICIT_TEMPLATE_ template <>

        //--------------------------------------------------------------------
		#define NATLIB_INIT {set_new_handler(null);}

		// xalloc is not defined in VC4.xx/VC5.xx
        //--------------------------------------------------------------------
        #define NATLIB_XALLOC TXLowMemory
		#define NATLIB_XALLOC_REQUESTED(x) (x.Requested())

        //--------------------------------------------------------------------
		#define NATLIB_FUNC_DECL(Declspec, ReturnType) Declspec ReturnType 

		//--------------------------------------------------------------------
		#ifdef WIN32
			#define NATLIB_GET_COMPATIBILITY_CORE \
				NWUTILS_Win32GetCompatibilityCore		
		#endif /*WIN32*/
    #else
        #error nlmsc.h compatibility header doesn't support Your compiler yet
    #endif /*(_MSC_VER >= 1000)*/
#else
	#error nlmsc.h can be only used with Microsoft compilers family
#endif /*_MSC_VER*/

#endif /*!defined(__NATLIB_NLMSC_H__)*/
