#ifndef __NATLIB_NLOPERAT_H__
#define __NATLIB_NLOPERAT_H__
/****************************************************************************/
/** nloperat.h                                                             **/
/** ---------------------------------------------------------------------- **/
/** Abstract operations definitions                                        **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** October 23, 1996 by Oleg Kagan                                         **/
/****************************************************************************/

//============================================================================
#include <nlobject.h>

//============================================================================
NATLIB_NAMESPACE_BEGIN

// TOperation
//============================================================================
typedef class _NATLIB_DECLSPEC_ TOperation : public virtual TNatlibObject {
public:
	//------------------------------------------------------------------------
    typedef TNatlibObject TParent;

	//------------------------------------------------------------------------
    NLEXCEPT_DECLARE(
		TException, TNatlibObject::TException, _NATLIB_DECLSPEC_
	) /*NLEXCEPT_DECLARE*/;
    NLEXCEPT_DECLARE_ABORT(TXAbort, TException, _NATLIB_DECLSPEC_);

	//------------------------------------------------------------------------
	virtual void Abort() const {throw TXAbort(THIS_CLASS);}

    //------------------------------------------------------------------------
	NLOBJECT_DECLARE_CLONE(TOperation);
} basic_TOperation;

// TOperationOn template
//============================================================================
template <class T> class _NATLIB_TEMPLATE_DECLSPEC_ TOperationOn : 
	public TOperation 
{
public:
	//------------------------------------------------------------------------
    typedef TOperation TParent;

	//------------------------------------------------------------------------
	NLEXCEPT_DECLARE(
		TException, TOperation::TException, _NATLIB_TEMPLATE_DECLSPEC_
	) /*NLEXCEPT_DECLARE*/;

	//------------------------------------------------------------------------
	NLOBJECT_DECLARE_CLONE1(TOperationOn, T) = 0;

	//------------------------------------------------------------------------
    virtual void operator()(T&) = 0;
} /*TOperationOn<T>*/;

// TConstantOperationOn template
//============================================================================
template <class T> class _NATLIB_TEMPLATE_DECLSPEC_ TConstantOperationOn :
	public virtual TOperationOn<T>
{
public:
	//------------------------------------------------------------------------
    typedef TOperationOn<T> TParent;

	//------------------------------------------------------------------------
	NLEXCEPT_DECLARE(
		TException, TOperationOn<T>::TException, 
		_NATLIB_TEMPLATE_DECLSPEC_
	) /*NLEXCEPT_DECLARE*/;

#ifndef _NATLIB_NO_EXTENDED_OVERLOADING_
	//------------------------------------------------------------------------
	NLOBJECT_DECLARE_CLONE1(TConstantOperationOn, T) = 0;
#endif /*_NATLIB_NO_EXTENDED_OVERLOADING_*/

    //------------------------------------------------------------------------
    virtual void operator()(const T& c_Data) = 0;

private:
	//------------------------------------------------------------------------
    void operator()(T& r_Data) {operator()((const T&)r_Data);}
} /*TConstantOperationOn<T>*/;

//============================================================================    
NATLIB_NAMESPACE_END

//============================================================================
#define NLOPERAT_DECLSPEC(T, Declspec) \
	NLOBJECT_DECLSPEC(T, Declspec); \
	NATLIB_EXPAND_TEMPLATE1( \
		NATLIB_NAMESPACE_MEMBER(TOperationOn), T, Declspec \
	) /*NATLIB_EXPAND_TEMPLATE1*/; \
	NATLIB_EXPAND_TEMPLATE1( \
		NATLIB_NAMESPACE_MEMBER(TConstantOperationOn), T, Declspec \
	) /*NATLIB_EXPAND_TEMPLATE1*/

#endif /*!defined(__NATLIB_NLOPERAT_H__)*/
