#ifndef __NATLIB_NWUTILS_H__
#define __NATLIB_NWUTILS_H__
/****************************************************************************/
/** nwutils.h                                                              **/
/** ---------------------------------------------------------------------- **/
/** Usefull C++ envelopes for Win32 functions                              **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** May 10, 1998 by Oleg Kagan                                             **/
/****************************************************************************/

// Natlib Win32 includes
//============================================================================
#include <nwerror.h>

//============================================================================
NATLIB_NAMESPACE_BEGIN

//============================================================================
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, TStdString) Win32GetCurrentUserA();
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, TStdString) Win32GetCurrentDomainA();
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32GetCurrentUserDomain(
	TStdString& r_sUser, TStdString& r_sDomain
) /*Win32GetCurrentUserDomain(TStdString&, TStdStirng&))*/;

#ifndef _NATLIB_NO_WIDE_STRINGS_
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, TWideString) Win32GetCurrentUserW();
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, TWideString) Win32GetCurrentDomainW();
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32GetCurrentUserDomain(
	TWideString&, TWideString&
) /*Win32GetCurrentUserDomain(TWideString&, TWideString&)*/;
#endif /*!defined(_NATLIB_NO_WIDE_STRINGS_) */

//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32GetCurrentUserDomain(
	wchar_t*, DWORD, wchar_t*, DWORD
) /*Win32GetCurrentUserDomain(wchar_t*, DWORD, wchar_t*, DWORD)*/;
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32GetProcessUserDomain(
	HANDLE, wchar_t*, DWORD, wchar_t*, DWORD
) /*Win32GetCurrentUserDomain(HANDLE, wchar_t*, DWORD, wchar_t*, DWORD)*/;

//============================================================================
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, bool) Win32IsFileExists(
	const char* c_szMask
) /*Win32IsFileExists(const char*)*/;
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, bool) Win32IsFileExists(
	const wchar_t* c_wszMask
) /*Win32IsFileExists(const wchar_t*)*/;
//----------------------------------------------------------------------------
inline bool Win32IsFileExists(const TStdString& c_sMask)
{
	return Win32IsFileExists(c_sMask.c_str());
} /*Win32IsFileExists(const TStdString&)*/;
#ifndef _NATLIB_NO_WIDE_STRINGS_
//----------------------------------------------------------------------------
inline bool Win32IsFileExists(const TWideString& c_wsMask)
{
	return Win32IsFileExists(c_wsMask.c_str());
} /*Win32IsFileExists(const TWideString&)*/;
#endif /*!defined(_NATLIB_NO_WIDE_STRINGS_)*/

//============================================================================
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, HKEY) Win32RegCreateKey(
	HKEY hParent, const char* c_szKey
) /*Win32RegCreateKey(HKEY, const char*)*/;
//---------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, HKEY) Win32RegCreateKey(
	HKEY hParent, const wchar_t* c_wszKey
) /*Win32RegCreateKey(HKEY, const wchar_t*)*/;
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32RegSetValue(
	HKEY hKey, const char* c_wszName, const char* c_wszValue,
	bool bExpand = false
) /*Win32RegSetValue(HKEY, const char*, const char*, bool = false)*/;
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32RegSetValue(
	HKEY hKey, const wchar_t* c_wszName, const wchar_t* c_wszValue,
	bool bExpand = false
) /*Win32RegSetValue(HKEY, const wchar_t*, const wchar_t*, bool = false)*/;

//============================================================================
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32RegisterShellFileType(
	const char* c_szDescription,  const char* c_szExtension, 
	const char* c_szDefaultIcon,
	const char* c_szOperation, const char* c_szCommandLine, 
	bool bDefaultOperation = false
) /*Win32RegisterShellFileType(const char*, const char*, const char*, ...)*/;
//----------------------------------------------------------------------------
NATLIB_FUNC_DECL(_NATLIB_DECLSPEC_, void) Win32RegisterShellFileType(
	const wchar_t* c_szDescription, const wchar_t* c_wszExtension, 
	const wchar_t* c_wszDefaultIcon,
	const wchar_t* c_wszOperation, const wchar_t* c_wszCommandLine,
	bool bDefaultOperation = false
) /*Win32RegisterShellFileType(const wchar_t*, const wchar_t*, ...)*/;

//============================================================================
NATLIB_NAMESPACE_END

#endif /*!defined(__NATLIB_NWUTILS_H__)*/