/****************************************************************************/
/** nlbintre.cpp                                                           **/
/** ---------------------------------------------------------------------- **/
/** Container implementation based on binary tree data structure           **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** October 22, 1996 by Oleg Kagan                                         **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>
#pragma hdrstop

//============================================================================
#include <nlbintre.h>

//============================================================================
NATLIB_NAMESPACE_BEGIN

// TBinaryTreeNode implementation
//============================================================================
TBinaryTreeNode*& TBinaryTreeNode::GetMaxNodePtr(

	TBinaryTreeNode*& r_pSubtree

){
	if (!r_pSubtree) // guard
		throw TXBadParameter(THIS_PLACE); 

	register TBinaryTreeNode** p_pNode = &r_pSubtree;
	while ((*p_pNode)->pRight) p_pNode = &(*p_pNode)->pRight;
	return *p_pNode;
} /*TBinaryTreeNode::GetMaxNodePtr(TBinaryTreeNode*&)*/;

//----------------------------------------------------------------------------
TBinaryTreeNode*& TBinaryTreeNode::GetMinNodePtr(

	TBinaryTreeNode*& r_pSubtree

){
	if (!r_pSubtree) // guard
		throw TXBadParameter(THIS_PLACE); 

	register TBinaryTreeNode** p_pNode = &r_pSubtree;
	while ((*p_pNode)->pLeft) p_pNode = &(*p_pNode)->pLeft;
	return *p_pNode;
} /*TBinaryTreeNode::GetMinNodePtr(TBinaryTreeNode*&)*/;

//----------------------------------------------------------------------------
TBinaryTreeNode* TBinaryTreeNode::DisconnectNode(

	TBinaryTreeNode*& r_pNode

){
	TBinaryTreeNode* pNodeToDelete = r_pNode;
	if (pNodeToDelete) {
		if (!r_pNode->pLeft) r_pNode = r_pNode->pRight;
		else if (!r_pNode->pRight) r_pNode = r_pNode->pLeft;
		else {
			// get biggest element in left subtree and delete it
			// from the structure
			//---------------------------------------------------
			TBinaryTreeNode* pReplaceNode = DisconnectNode(
				GetMaxNodePtr(r_pNode->pLeft)
			) /*DisconnectNode*/;

			pReplaceNode->pLeft = r_pNode->pLeft;
			pReplaceNode->pRight = r_pNode->pRight;

			r_pNode = pReplaceNode;
		} /*if*/

		pNodeToDelete->pLeft = pNodeToDelete->pRight = null;
	} /*if*/
	return pNodeToDelete;
} /*TBinaryTreeNode::DisconnectNode(TBinaryTreeNode*& r_pNode)*/;

// TBinaryTreeRebuildHelper implementation
//============================================================================
TBinaryTreeNode* TBinaryTreeRebuildHelper::BuildInsertList(

	TBinaryTreeNode* pRoot

){
	if (pRoot) {
		pInsertPlace = pRoot;
		PreorderList(pRoot->pRight);
		PreorderList(pRoot->pLeft);
		pInsertPlace->pRight = null; // End of list
	} /*if*/
	return pRoot;
} /*TBinaryTreeRebuildHelper::BulidInsertList(TBinaryTreeNode*)*/

//----------------------------------------------------------------------------
void TBinaryTreeRebuildHelper::PreorderList(

	TBinaryTreeNode* pNode

){
	while (pNode) {
		// Inlist
		//--------
		pInsertPlace->pRight = pNode;
		pInsertPlace = pNode;

		// Recursion
		//-----------
		BuildInsertList(pNode->pRight);

		// Tail recursion
		//----------------
		pNode = pNode->pLeft;
	} /*while*/
} /*TBinaryTreeRebuildHelper::PreorderList(TBinaryTreeNode*)*/

//============================================================================
NATLIB_NAMESPACE_END
