/****************************************************************************/
/** nllist.cpp                                                             **/
/** ---------------------------------------------------------------------- **/
/** Contents declarations of the double linked list and helper classes     **/
/** Note: Copy contructor for template argument must be available          **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** February 06, 1996 by Oleg Kagan & Ilya Marchevsky                      **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>
#pragma hdrstop

//============================================================================
#include <nllist.h>

//============================================================================
NATLIB_NAMESPACE_BEGIN

// TListReferenceCounter implementation
//============================================================================
TListReferenceCounter::~TListReferenceCounter()
{
    if (References()) 
		throw TXDestructionOfReferencedObject(THIS_CLASS);
} /*~TListReferenceCounter()*/

//----------------------------------------------------------------------------
void TListReferenceCounter::RegisterReference()
{
    if (!++nReferences) 
		throw TXInvalidReferenceCounter(THIS_CLASS);
} /*TListReferenceCounter::RegisterReference()*/

//----------------------------------------------------------------------------
void TListReferenceCounter::UnregisterReference()
{
    if (!nReferences--) 
		throw TXInvalidReferenceCounter(THIS_CLASS);
} /*TListReferenceCounter::UnregisterReference()*/

//============================================================================
NATLIB_NAMESPACE_END
