/****************************************************************************/
/** nllock.cpp                                                             **/
/** ---------------------------------------------------------------------- **/
/** Natlib syncronization facility base                                    **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** June 14, 1996 by Oleg Kagan                                            **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>
#pragma hdrstop

//============================================================================
#include <nllock.h>
#include <nlstring.h>

//============================================================================
NATLIB_NAMESPACE_BEGIN

// TLock implementation
//============================================================================
const nl_ulong_t TLock::c_uWaitInfinite = ~(nl_ulong_t)0;

//----------------------------------------------------------------------------
TNatlibStdString TLock::Dump() const
{
	TNatlibStdString sDump(TParent::Dump());
	if (IsLocked()) sDump += " locked by " + Format("%p", pc_Key);
	else sDump += " unlocked";
	return sDump;
} /*TLock::Dump() const*/

//----------------------------------------------------------------------------
NLOBJECT_CLONE_RESULT(TLock) TLock::Clone() const 
{
	TLock* pCopy; 
	NLEXCEPT_CLASS_NEW(TLock(), pCopy); 
	return pCopy; 
} /*TLock::Clone() const*/

//----------------------------------------------------------------------------
void TLock::Lock(

	const void* pc_LockKey,
    nl_ulong_t

){
	if (!pc_LockKey) 
		throw TXInvalidKey(THIS_CLASS);
	if (pc_Key) 
		throw TXBusy(THIS_CLASS);
	pc_Key = pc_LockKey;
} /*TLock::Lock*/

//----------------------------------------------------------------------------
void TLock::Unlock(

	const void* pc_LockKey

){
	if (pc_Key) {
		if (pc_Key != pc_LockKey) {
			throw TXInvalidKey(THIS_CLASS);
		}
		else {
			pc_Key = null;
		} /*iff*/
	} /*if*/
} /*TLock::Unlock*/

//============================================================================
NATLIB_NAMESPACE_END



