/****************************************************************************/
/** nlobject.cpp                                                           **/
/** ---------------------------------------------------------------------- **/
/** The virtual base of all Natlib objects defined here                    **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/** June 14, 1996 by Oleg Kagan                                            **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>
#pragma hdrstop

//============================================================================
#include <nlobject.h>

//============================================================================
NATLIB_NAMESPACE_BEGIN

// class TNatlibInitializer implementation
//============================================================================
TNatlibInitializer::TNatlibInitializer() _NATLIB_THROW_NONE_
{
	NATLIB_INIT;	
} /*TNatlibInitializer*/

//----------------------------------------------------------------------------
TNatlibInitializer::~TNatlibInitializer() _NATLIB_THROW_NONE_
{} /*~TNatlibInitializer*/

// class TNatlibObject implementation
//============================================================================
TNatlibObject::~TNatlibObject()
{} /*~TNatlibObject*/

//----------------------------------------------------------------------------
void TNatlibObject::AssertValid() const
{} /*TNatlibObject::AssertValid() const*/

//----------------------------------------------------------------------------
TNatlibStdString TNatlibObject::Dump() const
{
	TNatlibStdString sDump = typeid(*this).name();
	try {AssertValid();}
    catch (TException& c_Exception) {
		sDump += " is invalid because ";
        sDump += c_Exception.Why();
 	} /*catch (TException&)*/
    catch (...) {
		sDump += " is invalid...";
    } /*catch(...)*/
	return sDump;
} /*TNatlibObject::Dump() const*/

//----------------------------------------------------------------------------
TNatlibObject* TNatlibObject::ConstructFrom(

	const TNatlibObject& c_Object

) const {
	throw TXCanNotBeConstructed(THIS_CLASS, typeid(c_Object), typeid(*this));
	return null;
} /*TNatlibObject::ConstructFrom*/

//----------------------------------------------------------------------------
TNatlibInitializer TNatlibObject::NatlibInitializer;

//============================================================================
NATLIB_NAMESPACE_END

