/****************************************************************************/
/** test.cpp                                                               **/
/** ---------------------------------------------------------------------- **/
/** Copyright (C) 1996-98 by OK Thinking Software, All Rights Reserved     **/
/** ---------------------------------------------------------------------- **/
/****************************************************************************/

//============================================================================
#include <nlcompat.h>
#pragma hdrstop

// Standard includes
//============================================================================
#include <iostream.h>
#ifdef __BORLANDC__
#include <cstring.h>
#endif /*__BORLANDC__*/

// Natlib Basics includes
//============================================================================
#include <nlstring.h>
#include <nlexcept.h>

// Natlib Win32 includes
//============================================================================
#include <nwconsol.h>

//============================================================================
USING_NATLIB_NAMESPACE

//============================================================================
void Main(

	int /*argc*/,
	char* /*argv*/[]

){
	SzCmp("Hello", c_szNull);
    
	// Natlib Basics examples
    //------------------------
#ifdef NEVER
	extern void AutoPointerExample(); // TAutoPinterTo template
    AutoPointerExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void MultithreadLockExample(); // TWin32Lock
	MultithreadLockExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void AllocationAwareExample(); // TAllocationAware
	AllocationAwareExample();
#endif NEVER

#ifdef NEVER
	extern void BinaryTreeExample();  // TBinaryTreeOf template
    BinaryTreeExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void StorageExample(); // TStorageOf template
    StorageExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void SafeHandleExample(); // TSafeHandleOf template
    SafeHandleExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void VectorExample(); // TVectorOf template
    VectorExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void ListExample(); // TListOf template
    ListExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void StackExample(); // TStackOf template
    StackExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void TimeExample(); // TTime
    TimeExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void SingleExample(); // TSingleOf template
    SingleExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void LiteStackExample(); // TLiteStack
    LiteStackExample();
#endif /*NEVER*/

#ifdef NEVER
	extern void AtomExample(); // Natlib tasks
    AtomExample();
#endif /*NEVER*/

	// Natlib Tasks examples
    //-----------------------
//#ifdef NEVER
	extern void TasksExample(); // Natlib tasks
    TasksExample();
//#endif /*NEVER*/
} /*Main*/

//============================================================================
int main(

	int argc,
	char* argv[]

){
	try {
		// Syncronize C++ console I/O with Win32 console I/O
		//---------------------------------------------------
#if !defined(__BORLANDC__)
		ios::sync_with_stdio();
#endif /*!defined(__BORLANDC__)*/

		// Display compiler version
		//--------------------------
#if defined(__BORLANDC__)
		hex(cout);
		cout << "Borland C++ version : " << __BORLANDC__ << endl;
		dec(cout);
#elif defined(_MSC_VER)
		cout << "Visual C++ version : " << _MSC_VER << endl;
#else
		cout << "Unknown compiler" << endl;
#endif /*Compiler version*/
	    TWin32Console::Pause("Press any key...");
	    cout << endl;

		Main(argc, argv);
	}
	catch (const TNatlibException& c_Exception) {
		cout << "Natlib Exception : " << c_Exception.Why().c_str() << endl;
#ifdef __BORLANDC__
		cout << "Compiler Info    : " << __throwExceptionName;
		cout << " at [" << __throwFileName << ":" << __throwLineNumber << "]";
#endif __BORLANDC__
	} /*catch (const TException&)*/
#ifdef __BORLANDC__
	catch (const xmsg& c_XMessage) {
    	TNatlibStdString s = c_XMessage.why().c_str();
		cout << "Exception xmsg   : " << c_XMessage.why() << endl;
		cout << "Compiler Info    : " << __throwExceptionName;
		cout << " at [" << __throwFileName << ":" << __throwLineNumber << "]";
    } /*catch (const xmsg&)*/
#endif __BORLANDC__
	catch (...) {
		cout << "Unknown exception!" << endl;
#ifdef __BORLANDC__
		cout << "Compiler Info    : " << __throwExceptionName;
		cout << " at [" << __throwFileName << ":" << __throwLineNumber << "]";
#endif /*__BORLANDC__*/

	} /*catch (...)*/
	TWin32Console::Pause("\n\rPress any key to exit...");
	cout << endl;

	return false;
} /*main*/
